Seuls les membres ayant 30 points peuvent parler sur le chat.

Forum Casio - Projets de programmation


Index du Forum » Projets de programmation » fxSDK, un SDK alternatif pour écrire des add-ins
LephenixnoirEn ligneAdministrateurPoints: 16484 Défis: 140 Message

fxSDK, un SDK alternatif pour écrire des add-ins

Posté le 29/08/2014 22:00

Le fxSDK est une alternative au SDK habituel de Casio. Il permet de développer des add-ins pour la famille de la Graph 35+E et la Graph 90+E, et offre de meilleures performances et plus de possibilités !

Les outils du fxSDK

Le fxSDK marche sous Linux et a été compilé pour Mac OS ; il ne marche pas encore pour Windows mais on peut en discuter.

Il se fonde sur l'indispensable compilateur gcc et sa suite d'outils : as, ld, objdump, objcopy (entre autres). Contrairement au vieux compilateur du SDK, gcc est un compilateur moderne avec beaucoup de possibilités. Il n'est pas fourni avec le fxSDK et fait l'objet d'un tutoriel d'installation à part.

Côté calculatrice, c'est le noyau gint qui fait le travail. Il remplace fxlib et une partie de l'OS pour vous offrir des fonctionnalités plus cool et plus rapides. Les add-ins développés avec le fxSDK utilisent gint toutes les trois lignes !

Le fxSDK fournit également des outils spécifiques pour compiler et étudier les programmes de la calculatrice.

fxsdk est un petit gestionnaire de projet qui vous permet de créer et compiler facilement des projets sans vous prendre la tête avec le Makefile. Parfait si vous ne voulez pas connaître toutes les détails compliqués.

fxg1a sert à créer les fichiers g1a finaux à partir du programme compilé. C'est le successeur de mon vieux g1a-wrapper qui était beaucoup moins puissant.

fxconv convertit des données pour vos add-ins, commes vos images ou polices, dans des formats spécifiques de gint. C'est un peu comme le Sprite Coder mais ça vous évite de copier des gros tableaux dans votre programme et surtout le dessin est beaucoup plus performant !

fxos est un désassembleur et manipulateur d'OS capable de retrouver et disséquer des syscalls en un tour de poignet. C'est un outil de reverse-engineering dont l'usage principal est de produire des listings assembleur annotés pour comprendre très rapidement le code.

Il y a pas mal de différences avec le SDK de Casio donc passer au fxSDK nécessite un peu d'adaptation.

Installer le fxSDK sur votre ordinateur

Ça se passe en trois étapes :

1. Compiler un compilateur gcc à destination de la calculatrice
2. Installer le fxSDK
3. Installer le noyau, gint

Je suppose ici que vous connaissez les bases de la ligne de commande, mais si ce n'est pas le cas, n'hésitez pas à laisser un commentaire pour demander.

La première chose est de vous préparer un cross-compilateur gcc. Vous pouvez sauter l'installation du g1a-wrapper et venir ici dès que la libgcc est installée. Assurez-vous que le compilateur est dans le PATH est vous serez prêt ! C'est le plus gros morceau donc une fois que vous aurez ça, vous aurez déjà pratiquement fini.

Clônez le dépôt git du fxSDK depuis la forge de Planète Casio (vous pouvez aussi utiliser SSH).

% git clone 'https://gitea.planet-casio.com/Lephenixnoir/fxsdk.git'

Configurez le fxSDK ; vous pouvez taper "./configure --help" voir les options disponibles. Par défaut, le fxSDK sera installé dans votre dossier personnel (dans ".local").

% cd fxsdk
% ./configure

Ensuite compilez et installez ! Si vous avez choisi un dossier d'installation différent avec --prefix ou si vous compilez sous Mac, vous pourriez avoir besoin de sudo à l'installation.

% make
% make install

Assurez-vous que votre dossier de destination est dans votre PATH, puis vous pouvez installer gint.

Vous êtes alors prêt à partir !

Développer des programmes avec le fxSDK

TODO: Ajouter l'utilisation de fxsdk.

Toute la partie programmation revient à développer des programmes avec gint. Les tutoriels d'utilisation de gint couvrent tous ce dont vous aurez besoin, y compris l'utilisation de fxconv.


Fichier joint


Pages : Précédente1, 2, 3, 4, 5, 6, 7, ... 24Suivante
NemhardyHors ligneGrand maître des Traits d'EspritPoints: 1235 Défis: 54 Message

Citer : Posté le 30/08/2014 17:20 | #


J'ai vu que tu avais inclus du français dans la zone avec la sortie du compilateur, du coup ça pourrait peut-être être sympa de préciser dans le tuto pour compiler GCC que enlever "--disable-nls" permet d'avoir les messages de sortie du compilateur en français, pour harmoniser le tout (et avoir un truc encore plus user friendly), tout en précisant que des messages en français réduiront la quantité de résultats si on recherche des infos à propos d'une erreur sur Google (perso je l'ai toujours en anglais, mais les erreurs sont peut-être plus compréhensibles par des débutants si elles sont exprimées en français ?).
N'attendez pas qu'il n'y ait plus de miel : スススススススススススススススススススススススススス養蜂家スススススススススススススススススススススススススススススススススススス蜂家
LephenixnoirEn ligneAdministrateurPoints: 16484 Défis: 140 Message

Citer : Posté le 30/08/2014 17:25 | #


Non, je pense qu'il vaut mieux laisser le compilo en anglais... la programmation en général c'est de l'anglais, et si un certain nombre des programmeurs pour caltos le sont pour "se faire la main", autant ne pas donner de mauvaises habitudes.

Après j'ai tenté de tout mettre en français, mais je me rends compte que j'ai pas réussi ; il y a encore de l'anglais dans tous ces "Source files" et autres "Header files".

Après je pense pas que ce soit forcément intéressant d'adapter l'UI pour l'anglais, donc pour l'instant je laisse comme ça.

Ajouté le 03/09/2014 à 21:24 :
Je viens de passer à Qt 5 sur mon PC. Le projet compile plus, mais je pense que ce ne sont que des différences d'API mineures.
La bêta utilisera donc la dernière version stable de Qt.
IntelligideHors ligneMembre de CreativeCalcPoints: 46 Défis: 5 Message

Citer : Posté le 03/09/2014 21:33 | #


Si tu utilises Qt5.3.1, je pense qu'il ne sera pas compatible avec vista et inférieur
LephenixnoirEn ligneAdministrateurPoints: 16484 Défis: 140 Message

Citer : Posté le 03/09/2014 21:34 | #


Et pourquoi pas ?
D'après qt-project.org, il est compatible avec toutes les versions de windows.
IntelligideHors ligneMembre de CreativeCalcPoints: 46 Défis: 5 Message

Citer : Posté le 03/09/2014 21:38 | #


Qt est compatible avec toutes les versions mais pas les programmes compilées avec, enfin je pense,

parce que j'avais un
à chaque lancement de mon programme
quand je suis passé à la version 5.3.1 de Qt mais je n'avais pas cette erreur si j'utilisais une version inférieur
LephenixnoirEn ligneAdministrateurPoints: 16484 Défis: 140 Message

Citer : Posté le 03/09/2014 21:40 | #


D'ailleurs, je ne sais même pas pourquoi je me pose la question.

T'as pas encore compris la répartition des rôles ?
IntelligideHors ligneMembre de CreativeCalcPoints: 46 Défis: 5 Message

Citer : Posté le 03/09/2014 21:42 | #


fxSDK = Linux

Dsl

:boulet:

:aie2:



:boobs: :kiss:
LephenixnoirEn ligneAdministrateurPoints: 16484 Défis: 140 Message

Citer : Posté le 03/09/2014 21:43 | #


Ben voilà, tu vois quand tu veux.

Parce que mettons-nous d'accord, il est beaucoup plus facile d'adapter le fxSDK pour CG ou le SDKolor pour G85 que de les adapter chacun pour windows et linux respectivement.
IntelligideHors ligneMembre de CreativeCalcPoints: 46 Défis: 5 Message

Citer : Posté le 03/09/2014 21:44 | #


lephenixnoir +1
Dark stormEn ligneMembre d'honneurPoints: 10872 Défis: 176 Message

Citer : Posté le 03/09/2014 21:50 | #



Je suis moins présent depuis 3 jours, qu'est-ce que je vois en faisant un tour
Finir est souvent bien plus difficile que commencer. — Jack Beauregard
LephenixnoirEn ligneAdministrateurPoints: 16484 Défis: 140 Message

Citer : Posté le 03/09/2014 21:52 | #


C'est Intelligide
J'ai quelques problèmes avec Qt 5, je vais voir ce que je peux faire.
IntelligideHors ligneMembre de CreativeCalcPoints: 46 Défis: 5 Message

Citer : Posté le 03/09/2014 21:54 | #


roh l'autre c'est toujours la faute des autres (allez j'avoue c'est pas moi , c'est mon moi n2)
LephenixnoirEn ligneAdministrateurPoints: 16484 Défis: 140 Message

Citer : Posté le 03/09/2014 21:55 | #


Toi aussi tu es multizophrène ?
IntelligideHors ligneMembre de CreativeCalcPoints: 46 Défis: 5 Message

Citer : Posté le 03/09/2014 21:57 | #


Non seulement octophrène(vite y a un stop)
Dark stormEn ligneMembre d'honneurPoints: 10872 Défis: 176 Message

Citer : Posté le 03/09/2014 21:58 | #


Stop HS, sinon ménage
Finir est souvent bien plus difficile que commencer. — Jack Beauregard
LephenixnoirEn ligneAdministrateurPoints: 16484 Défis: 140 Message

Citer : Posté le 05/09/2014 13:36 | #


J'arrive pas encore à compiler avec Qt 5. En revanche, je sais plus ou moins pourquoi.
En gros, j'ai le même bug que lorsque j'avais tenté de compiler le fxSpriter (codeur d'images) sous windows. Autrement dit, c'est purement lié à la version et une fois que j'aurai résolu ce bug je serai tranquille pour tout ce qui est compilation sous windows (même si ça ne concerne pas le fxSDK).

Pour faire simple, les classes ne sont plus reconnues... donc impossible de faire quoi que ce soit. oO
D'ailleurs, je crois que je sais d'où vient le bug, maintenant que j'y pense.

Ajouté le 05/09/2014 à 13:42 :
Bon ben voilà... problème résolu.

Avant les widgets se trouvaient dans la section de la lib appelé QtGui (qui contenait tout), et depuis Qt 5 ils se trouvent dans QtWidgets. Et comme du coup j'incluais pas ce dernier header, je n'avais aucune classe.
EiyeronHors ligneAncien modérateurPoints: 5513 Défis: 57 Message

Citer : Posté le 05/09/2014 13:47 | #


Bon bah ya plus qu'à faire un émulateur!
LephenixnoirEn ligneAdministrateurPoints: 16484 Défis: 140 Message

Citer : Posté le 05/09/2014 13:49 | #


Je commence à me poser la question. En soi c'est facilement faisable si je prends le fls et que je le boote au bon endroit
EiyeronHors ligneAncien modérateurPoints: 5513 Défis: 57 Message

Citer : Posté le 05/09/2014 13:50 | #


Il va y avoir du boulot à faire. le CPU n'est pas trop dur en théorie (la structure se rédige peu à peu du coté de FiXOS et ya celle de RFX), c'est surtout les périphs qu'il va falloir émuler et çe sera une tout autre difficulté. Si tu veux t'y mettre, je te souhaite bonne chance, car cela va pas être évident.
LephenixnoirEn ligneAdministrateurPoints: 16484 Défis: 140 Message

Citer : Posté le 05/09/2014 13:56 | #


Je plaisantais surtout , après à mon avis le concept de réutiliser l'OS en dur peut fonctionner.
Les périphériques, on s'en occuperait plus tard, faire tourner un fls serait déjà un beau progrès (d'autant plus qu'il ne serait je suppose, pas bridé -- à voir d'ailleurs si CASIO ne râlerait pas de ce côté-là).

Enfin ça... on verra si je m'y penche -- pour l'instant ce n'est pas prévu.
EiyeronHors ligneAncien modérateurPoints: 5513 Défis: 57 Message

Citer : Posté le 05/09/2014 14:01 | #


Bah, sans les périphs comme le clavier ou l'écran... Kris m'a dit qu'un de vous avait déjà réussi à lancer la ROM (ou du moins arriver à "Initialization").

Par contre, c'est la gray zone, une fois un ému complet réalisé, il faudra être bien plus strict concernant le partage de fls... Pas de fls venant de Casio (on verra bien après pour FiXOS)
Pages : Précédente1, 2, 3, 4, 5, 6, 7, ... 24Suivante

Planète Casio v42 © créé par Neuronix et Muelsaco 2004 - 2019 | Il y a 111 connectés | Nous contacter | Qui sommes-nous ? | Licences et remerciements

Planète Casio est un site communautaire non affilié à Casio. Toute reproduction de Planète Casio, même partielle, est interdite.
Les programmes et autres publications présentes sur Planète Casio restent la propriété de leurs auteurs et peuvent être soumis à des licences ou copyrights.
CASIO est une marque déposée par CASIO Computer Co., Ltd